require "json"

class Requests::Login
	JSON.mapping({
		type: String,
		login: String,
		password: String
	})
end

class Requests::Tasks
	JSON.mapping({
		type: String,
		project: String
	})
end

class Requests::NewProject
	JSON.mapping({
		type: String,
		name: String
	})
end

class Requests::EditProject
	JSON.mapping({
		type: String,
		project: String,
		name: String?,
		color: String?
	})
end

class Requests::NewColumn
	JSON.mapping({
		type: String,
		project: String,
		name: String
	})
end

class Requests::NewTask
	JSON.mapping({
		type: String,
		project: String,
		column: String,
		title: String,
		description: String
	})
end

class Requests::EditTask
	JSON.mapping({
		type: String,
		project: String,
		task: String,
		column: String?,
		title: String?,
		description: String?,
		assigned_to: Int32?,
		color: String?
	})
end

class Requests::DeleteTask
	JSON.mapping({
		type: String,
		project: String,
		task: String
	})
end

class Requests::EditColumn
	JSON.mapping({
		type: String,
		project: String,
		column: String,
		name: String?
	})
end

class Requests::DeleteColumn
	JSON.mapping({
		type: String,
		project: String,
		column: String
	})
end

class Requests::GetUser
	JSON.mapping({
		type: String,
		uid: Int32
	})
end

